import sys

from PyQt4.QtGui import (
    QAction,
    QStyle,
    QMainWindow,
    QApplication,
)
from PyQt4.QtCore import Qt



class MainUI(QMainWindow):
    """Main UI."""

    def __init__(self):
        super(MainUI, self).__init__()
        self.setWindowTitle('Qt Icons')
        self.resize(500, 300)

        # get attribs and group by prefix
        attribs = {}
        for name in dir(QStyle):
            parts = name.split('_')
            if len(parts) > 1 and parts[0] == 'SP':  # only "standard pixmaps"
                for i, w in enumerate(name[4:], 4):
                    if w.isupper():
                        break
                prefix = name[3:i]
                attribs.setdefault(prefix, []).append(name)

        # regroup those that are alone
        grouped = []
        for prefix, names in attribs.items():
            if len(names) == 1:
                grouped.append(names[0])
                del attribs[prefix]
        attribs['Zz'] = grouped

        # build toolbars
        for prefix, names in sorted(attribs.items()):
            toolbar = self.addToolBar(prefix)
            self.insertToolBarBreak(toolbar)
            for name in sorted(names):
                icon = self.style().standardIcon(getattr(QStyle, name))
                action = QAction(icon, name, self)
                action.setToolTip(name)
                action.triggered.connect(lambda _, n=name: self._inform(n))
                toolbar.addAction(action)
        self.show()

    def _inform(self, name):
        """Tell user the name of the icon."""
        print "Icon name:", name


app = QApplication(sys.argv)
m = MainUI()
sys.exit(app.exec_())
